gc: find all the dirty bits
[girocco.git] / jobd / gc.sh
blobbd368b98c532330567e9f1cc21448ec7af908fec
1 #!/bin/sh
3 # NOTE: additional options can be passed to git repack by specifying
4 # them after the project name, for example:
5 # gc.sh my-project -f
7 . @basedir@/shlib.sh
9 set -e
11 if [ $# -lt 1 ]; then
12 echo "Usage: gc.sh projname [extra-repack-args]" >&2
13 exit 1
16 # Includes
17 _shlib_done=1
18 unset GIROCCO_SUPPRESS_AUTO_GC_UPDATE
19 . "$cfg_basedir/jobd/maintain-auto-gc-hack.sh"
20 . "$cfg_basedir/jobd/generate-auto-gc-update.sh"
21 GIROCCO_SUPPRESS_AUTO_GC_UPDATE=1 && export GIROCCO_SUPPRESS_AUTO_GC_UPDATE
23 # packing options
24 packopts="--depth=50 --window=50 --window-memory=${var_window_memory:-1g}"
25 quiet="-q"; [ "${show_progress:-0}" = "0" ] || quiet=
27 umask 002
28 [ "$cfg_permission_control" != "Hooks" ] || umask 000
29 clean_git_env
31 vcnt() {
32 eval "$1="'$(( $# - 1 ))'
35 pidactive() {
36 if _result="$(kill -0 "$1" 2>&1)"; then
37 # process exists and we have permission to signal it
38 return 0
40 case "$_result" in *"not permitted"*)
41 # we do not have permission to signal the process
42 return 0
43 esac
44 # process does not exist
45 return 1
48 createlock() {
49 # A .lock file should only exist for much less than a second.
50 # If we see a stale lock file (> 1h old), remove it and then,
51 # just in case, wait 30 seconds for any process whose .lock
52 # we might have just removed (it's racy) to finish doing what
53 # should take much less than a second to do.
54 _stalelock="$(find -L "$1.lock" -maxdepth 1 -mmin +60 -print 2>/dev/null)" || :
55 if [ -n "$_stalelock" ]; then
56 rm -f "$_stalelock"
57 sleep 30
59 for _try in p p n; do
60 if (set -C; >"$1.lock") 2>/dev/null; then
61 echo "$1.lock"
62 return 0
64 # delay and try again
65 [ "$_try" != "p" ] || sleep 1
66 done
67 # cannot create lock file
68 return 1
71 # The pre-receive script creates one ref log file per push but we want them to
72 # be coalesced into one ref log file per day. We are guaranteed that any files
73 # we find to coalesce are NOT currently being written to since they are always
74 # written first as temporary files and then moved into place. We attempt to
75 # transfer the most recent modification time to the coalesced log file which
76 # would step on its mod time if it were being written to directly, but if we
77 # find per-process ref log files then it must be a push project and the only
78 # thing that would write directly to the main per-day log file would be a
79 # mirror project so there's actually no conflict.
80 # Also, if the clock is wonky (or was futzed with) we may have both YYYYMMDD
81 # and YYYYMMDD.gz present in which case combine them into YYYYMMDD
82 coalesce_reflogs() {
83 [ -d reflogs ] || return 0
84 rm -f .gc_failed
85 find -L reflogs -maxdepth 1 -type f -name "[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]" -print |
86 while read -r rname; do
87 if [ -e "$rname.gz" ]; then
88 if [ -s "$rname" ]; then
89 # Presumably the .gz file must have been created before the non-gz
90 # file since it had to be uncompressed at some point therefore
91 # we need to append the non-gz contents to it but keep the non-gz
92 # contents timestamp so we rename to YYYYMMDD_ which will sort first
93 # and be picked up in the next step if we are interrupted in the middle.
94 # If a YYYYMMDD_ file already exists we append to it and transfer the
95 # timestamp. Finally we transfer the YYYYMMDD_ timestamp to the result
96 # and remove the YYYYMMDD_ temporary file leaving the result uncompressed.
97 if [ -e "${rname}_" ]; then
98 cat "$rname" >>"${rname}_"
99 touch -r "$rname" "${rname}_"
100 rm -f "$rname"
101 ! [ -e "$rname" ]
102 else
103 mv "$rname" "${rname}_"
105 gzip -d "$rname.gz" </dev/null
106 [ -e "$rname" ] && ! [ -e "$rname.gz" ]
107 cat "${rname}_" >>"$rname"
108 touch -r "${rname}_" "$rname"
109 rm -f "${rname}_"
110 else
111 # Just remove the empty file to resolve the problem
112 rm -f "$rname"
115 done
116 find -L reflogs -maxdepth 1 -type f -name "[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]_*" -print | LC_ALL=C sort |
117 while read -r rname; do
118 logname="${rname%%_*}"
119 # If someone's been futzing with the date, the file we want to
120 # append to could already have been compressed, so we just uncompress
121 # it here. The previous block guarantees we do not have both a compressed
122 # and uncompressed version present at the same time.
123 if [ -e "$logname.gz" ]; then
124 gzip -d "$logname.gz" </dev/null
125 [ -e "$logname" ] && ! [ -e "$logname.gz" ]
127 cat "$rname" >>"$logname"
128 touch -r "$rname" "$logname"
129 rm -f "$rname"
130 if [ -e "$rname" ]; then
131 >.gc_failed
132 echo "! [$proj] failed to remove $rname" >&2
133 exit 1 # will only exit subshell created by "|"
135 done
136 ! [ -e .gc_failed ]
139 # Remove any files in reflogs that are older than $cfg_reflogs_lifetime days
140 prune_reflogs() {
141 [ -d reflogs ] || return 0
142 exp="$(( ${cfg_reflogs_lifetime:-1} * 1440 ))"
143 [ $exp -gt 0 ] || exp=1440
144 [ $exp -le 43200 ] || exp=43200
145 find -L reflogs -maxdepth 1 -type f -mmin "+$exp" -exec rm -f '{}' + || :
148 # Compact any reflogs that are not today's UTC date unless a .gz version exists
149 compact_reflogs() {
150 [ -d reflogs ] || return 0
151 _td="reflogs/$(TZ=UTC date '+%Y%m%d')"
152 find -L reflogs -maxdepth 1 -type f -name "[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]" -print |
153 while read -r rname; do
154 [ "$rname" != "$_td" ] || continue
155 ! [ -e "$rname.gz" ] || continue
156 gzip -9 "$rname" </dev/null
157 done
160 # return true if there's more than one objects/pack-<sha>.pack file or
161 # ANY sha-1 files in objects or
162 # there's one pack and it's not a normal pack name or
163 # there's one pack but not any refs
164 is_dirty() {
165 _packs="$(find -L objects/pack -name "pre-auto-gc-[12].pack" -prune -o -name "*.pack" -type f -print 2>/dev/null | head -n 2)"
166 vcnt _packscnt $_packs
167 if [ $_packscnt -gt 1 ]; then
168 return 0
170 if [ $_packscnt -eq 1 ]; then
171 # the single pack name is in $_packs
172 _packs="${_packs%.pack}"
173 _packs="${_packs#objects/pack/}"
174 case "$_packs" in
175 pack-*)
176 _packs="${_packs#pack-}"
177 if [ "${#_packs}" -lt 40 ] || [ "${_packs#*[!0-9a-fA-F]}" != "$_packs" ]; then
178 # name not exclusively 40 or more hexadecimal digits makes it dirty
179 return 0
183 # abnormal name makes it dirty
184 return 0
186 esac
188 _objs=$(find -L objects/$octet -name "$octet19*" -type f -print 2>/dev/null | head -n 1 | LC_ALL=C wc -l)
189 [ $_objs -eq 0 ] || return 0
190 [ $_packscnt -eq 1 ] || return 1
191 # we do this check last because it's potentially the most expensive;
192 # at this point we know we do not have any loose objects, but we do
193 # have one pack that's named "normally"; empty refs => dirty
194 is_empty_refs_dir
197 # make sure combine-packs uses the correct Git executable
198 run_combine_packs() {
199 PATH="$var_git_exec_path:$cfg_basedir/bin:$PATH" @basedir@/jobd/combine-packs.sh "$@"
202 # duplicate the first file to the name given by the second file making sure that
203 # the second file appears atomically all-at-once after the copy has been completed
204 # and does not appear at all if the copy fails (in which case this function fails)
205 # if the second file already exists this function fails with status 1
206 # if the file names are the same this function returns immediately with success
207 dupe_file() {
208 [ "$1" != "$2" ] || return 0
209 ! [ -e "$2" ] || return 1
210 case "$2" in
211 *?/?*) _tmpdir="${2%/*}";;
212 *) _tmpdir=".";;
213 esac
214 _tmpfile="$(mktemp "${_tmpdir:-.}/packtmp-XXXXXX")" || return 1
215 cp -fp "$1" "$_tmpfile" || return 1
216 mv -f "$_tmpfile" "$2"
219 # rename_pack oldnamepath newnamepath
220 # note that .keep and .bndl files are left untouched and not moved at all!
221 rename_pack() {
222 [ $# -eq 2 ] && [ "$1" != "$2" ] || {
223 echo >&2 "[$proj] incorrect use of rename_pack function"
224 exit 1
226 # Git assumes that if the destination of the rename already exists
227 # that it is, in fact, a copy of the same bytes so silently succeeds
228 # without doing anything. We duplicate that logic here.
229 # Git checks for the .idx file first before even trying to use a pack
230 # so it should be the last moved and the first removed.
231 for ext in pack bitmap idx; do
232 [ -f "$1.$ext" ] || continue
233 ln "$1.$ext" "$2.$ext" >/dev/null 2>&1 ||
234 dupe_file "$1.$ext" "$2.$ext" >/dev/null 2>&1 ||
235 [ -f "$2.$ext" ] || {
236 echo >&2 "[$proj] unable to move $1.$ext to $2.$ext"
237 exit 1
239 done
240 for ext in idx pack bitmap; do
241 rm -f "$1.$ext"
242 done
243 return 0
246 # combine the input pack(s) into a new pack (or possibly packs if packSizeLimit set)
247 # input pack names are read from standard input one per line delimited by the first
248 # ':', ' ' or '\n' character on the line (which allows gfi-packs to be read directly)
249 # all arguments, if any, are passed to pack-objects as additional options
250 # returns non-zero on failure AND creates .gc_failed in that case
251 combine_packs() {
252 rm -f .gc_failed
253 find -L objects/pack -maxdepth 1 -type f -name '*.zap*' -exec rm -f '{}' + || :
254 run_combine_packs --replace "$@" $packopts --all-progress-implied $quiet --non-empty || {
255 >.gc_failed
256 return 1
258 return 0
261 # if the current directory is_gfi_mirror then repack all packs listed in gfi-packs
262 repack_gfi_packs() {
263 [ -n "$gfi_mirror" ] || return 0
264 [ -d objects/pack ] || { rm -f gfi-packs; return 0; }
265 progress "~ [$proj] redeltifying poor quality git fast-import packs"
266 combine_packs --ignore-missing --no-reuse-delta <gfi-packs
267 rm -f gfi-packs
268 return 0
271 # see if there are "lotsa" loose objects
272 # "lotsa" is defined as the 17, 68, 71 and 86 object directories existing
273 # and there being at least 5 total objects between them which corresponds
274 # to an approximate average of 320 loose objects before this function starts
275 # returning true and triggering a "mini" gc to pack up loose objects
276 lotsa_loose_objects() {
277 [ -d objects/17 ] && [ -d objects/68 ] && [ -d objects/71 ] && [ -d objects/86 ] || return 1
278 _objs=$(( $(find -L objects/17 objects/68 objects/71 objects/86 -maxdepth 1 -name "$octet19*" -type f -print 2>/dev/null | LC_ALL=C wc -l) ))
279 [ ${_objs:-0} -ge 5 ]
282 # pack any existing loose objects into a new _l.pack file then run prune-packed
283 # note that prune-packed is NOT run beforehand -- the caller must do that if needed
284 # loose objects need not be part of complete commits/trees as --weak-naming is used
285 pack_loose_objects() {
286 _lpacks="$(run_combine_packs </dev/null --names --loose --weak-naming --non-empty --all-progress-implied ${quiet:---progress} $packopts)"
287 if [ -n "$_lpacks" ]; then
288 # We need to identify these packs later so we don't combine_packs them
289 for _objpack in $_lpacks; do
290 rename_pack "objects/pack/pack-$_objpack" "objects/pack/pack-${_objpack}_l" || :
291 done
292 git prune-packed $quiet
296 # combine small packs into larger pack(s)
297 # we avoid any _[lo], keep, bndl or bitmap packs
298 # if the optional argument is non-empty even a single small pack will be redeltad
299 combine_small_packs() {
300 _didprogress=
301 _minsmallpacks=2
302 if [ -n "$1" ] && [ -n "$noreusedeltaopt" ]; then
303 _minsmallpacks=1
305 _lpo="--exclude-no-idx --exclude-keep --exclude-bitmap --exclude-bndl"
306 _lpo="$_lpo --exclude-sfx _u --exclude-sfx _o --exclude-sfx _l"
307 _lpo="$_lpo --quiet --object-limit $var_redelta_threshold objects/pack"
308 while
309 _cnt="$(list_packs --count $_lpo)" || :
310 test "${_cnt:-0}" -ge $_minsmallpacks
312 [ -n "$_didprogress" ] || {
313 progress "~ [$proj] combining small packs into a single larger pack"
314 _didprogress=1
316 _newp="$(list_packs $_lpo | combine_packs --names $noreusedeltaopt)"
317 vcnt _newc $_newp
318 # be paranoid and exit the loop if we haven't reduced the number of packs
319 [ $_newc -lt $_cnt ] || break
320 _minsmallpacks=2
321 done
322 return 0
325 # combine small _l packs into larger pack(s) using --weak-naming
326 # we avoid any non _l, keep, bndl or bitmap packs
327 # if the optional 2nd argument is non-empty even a single small pack will be redeltad
328 combine_small_loose_packs() {
329 _didprogress=
330 _minsmallpacks=2
331 if [ -n "$1" ] && [ -n "$noreusedeltaopt" ]; then
332 _minsmallpacks=1
334 _lpo="--exclude-no-idx --exclude-keep --exclude-bitmap --exclude-bndl"
335 _lpo="$_lpo --exclude-no-sfx _l"
336 _lpo="$_lpo --quiet --object-limit $var_redelta_threshold objects/pack"
337 while
338 _cnt="$(list_packs --count $_lpo)" || :
339 test "${_cnt:-0}" -ge $_minsmallpacks
341 [ -n "$_didprogress" ] || {
342 progress "~ [$proj] combining small loose packs into a single larger pack"
343 _didprogress=1
345 _newp="$(list_packs $_lpo | combine_packs --names --weak-naming $noreusedeltaopt)"
346 # We need to identify these packs later so we don't combine_packs them
347 for _objpack in $_newp; do
348 rename_pack "objects/pack/pack-$_objpack" "objects/pack/pack-${_objpack}_l" || :
349 done
350 vcnt _newc $_newp
351 # be paranoid and exit the loop if we haven't reduced the number of packs
352 [ $_newc -lt $_cnt ] || break
353 _minsmallpacks=2
354 done
355 return 0
358 # Unfortunately, some fetch strategies (e.g. git-svn and non-smart HTTP) lack
359 # the ability to store newly fetched objects in a pack.
360 # However, the fetch code conveniently sets .needspack just before it fetches
361 # so that it's easy to find all the loose objects that have been fetched and
362 # combine them into a pack. The --no-reuse-delta option is meaningless here
363 # since everything to be packed is a loose object and therefore not a delta so
364 # deltification will always take place.
365 make_needs_pack() {
366 [ -f .needspack ] || return 0
367 rm -f .needspackgc
368 mv -f .needspack .needspackgc
369 progress "~ [$proj] combining fetched loose objects into a pack"
370 _newp="$(find -L objects/$octet -maxdepth 1 -type f -newer .needspackgc -name "$octet19*" -print 2>/dev/null |
371 LC_ALL=C awk -F / '{print $2 $3}' |
372 run_combine_packs --objects --names $packopts --incremental --all-progress-implied $quiet --non-empty)" || {
373 # We used to fail gc here.
374 # Now, however, we just ignore the failure because we have
375 # another mechanism to handle loose objects and it's possible
376 # that the fetcher somehow brought in unconnected objects which
377 # would cause the above combine-packs to fail.
378 # By ignoring the failure and just removing the .needspack file
379 # the loose objects will be treated as "ordinary" loose objects
380 # and packed using the "--weak-naming" option which can handle
381 # broken connectivity.
382 # That's a better solution than just failing here or leaving
383 # .needspack behind to potentially continue to fail again and
384 # again.
385 _newp=
387 if [ -n "$_newp" ]; then
388 # remove the now-redundant loose objects -- this is always safe
389 # even during a concurrent push because a reprepare_packed_git
390 # will be triggered if an object that should be there is not
391 # found thereby finding it in the new pack instead
392 git prune-packed $quiet
394 rm -f .needspackgc
397 # HEADSHA="$(pack_is_complete /full/path/to/some.pack /full/path/to/packed-refs "$(cat HEAD)")"
398 pack_is_complete() {
399 # Must have a matching .idx file and a non-empty packed-refs file
400 [ -s "${1%.pack}.idx" ] || return 1
401 [ -s "$2" ] || return 1
402 _headsha=
403 case "$3" in
404 $octet20*)
405 _headsha="$3"
407 "ref: refs/"?*|"ref:refs/"?*|"refs/"?*)
408 _headmatch="${3#ref:}"
409 _headmatch="${_headmatch# }"
410 _headmatchpat="$(echo "$_headmatch" | LC_ALL=C sed -e 's/\([.$]\)/\\\1/g')"
411 _headsha="$(LC_ALL=C grep -e "^$octet20$hexdig* $_headmatchpat\$" <"$2" |
412 LC_ALL=C cut -d ' ' -f 1)"
413 case "$_headsha" in $octet20*) :;; *)
414 return 1
415 esac
418 # bad HEAD
419 return 1
420 esac
421 rm -rf pack_is_complete_test
422 mkdir pack_is_complete_test
423 mkdir pack_is_complete_test/refs
424 mkdir pack_is_complete_test/objects
425 mkdir pack_is_complete_test/objects/pack
426 echo "$_headsha" >pack_is_complete_test/HEAD
427 ln -s "$1" pack_is_complete_test/objects/pack/
428 ln -s "${1%.pack}.idx" pack_is_complete_test/objects/pack/
429 ln -s "$2" pack_is_complete_test/packed-refs
430 _count="$(git --git-dir=pack_is_complete_test rev-list --count --all 2>/dev/null)" || :
431 rm -rf pack_is_complete_test
432 [ -n "$_count" ] || return 1
433 [ "$_count" -gt 0 ] 2>/dev/null || return 1
434 echo "$_headsha"
437 # On return a "$lockf" will have been created that must be removed when gc is done
438 lock_gc() {
439 # be compatibile with gc.pid file from newer Git releases
440 lockf=gc.pid
441 hn="$(hostname)"
442 active=
443 if [ "$(createlock "$lockf")" ]; then
444 # If $lockf is:
445 # 1) less than 12 hours old
446 # 2) contains two fields (pid hostname) NO trailing NL
447 # 3) the hostname is different OR the pid is still alive
448 # then we exit as another active process is holding the lock
449 if [ "$(find -L "$lockf" -maxdepth 1 -mmin -720 -print 2>/dev/null)" ]; then
450 apid=
451 ahost=
452 read -r apid ahost ajunk <"$lockf" || :
453 if [ "$apid" ] && [ "$ahost" ]; then
454 if [ "$ahost" != "$hn" ] || pidactive "$apid"; then
455 active=1
459 else
460 echo >&2 "[$proj] unable to create gc.pid.lock file"
461 exit 1
463 if [ -n "$active" ]; then
464 rm -f "$lockf.lock"
465 echo >&2 "[$proj] gc already running on machine '$ahost' pid '$apid'"
466 exit 1
468 printf "%s %s" "$$" "$hn" >"$lockf.lock"
469 chmod 0664 "$lockf.lock"
470 mv -f "$lockf.lock" "$lockf"
473 # Create a repack subdirectory such that running repack in it will pack the
474 # same things that a pack in the normal directory would except that the pack
475 # is guaranteed to be generated in an optimized order by adding a suitable
476 # synthesized ref in the refs/tags namespace (yes, pack-objects.c really does
477 # behave differently depending on the contents of the refs/tags namespace).
478 # Before calling this, pack-refs --all MUST be performed or the wrong pack
479 # will end up being made.
481 # If a ref deletion is pushed after making the repack subdir but before the
482 # the actual repack, the discarded objects will be packed -- no big deal,
483 # they'll get discarded the next time gc runs.
485 # If a fast-forward ref update is pushed after making the repack subdir but
486 # before the actual repack, it will be picked up and the new objects packed
487 # (subject to the normal git repack race about picking such updates up).
489 # If a non-fast-forward ref update is pushed after making the repack subdir but
490 # before the actual repack, it will be picked up like a fast-forward update but
491 # the discarded objects will be included like a ref deletion (until the next
492 # scheduled gc takes place).
494 # We retain a copy of the original packed-refs file as repack/packed-refs.orig
495 # If ref deletions come in while we're repacking, the original packed-refs
496 # file will be modified, but we'll still pack the deleted ref(s).
497 # If the packed-refs.orig file is used to create the bundle header we avoid
498 # a situation where the bundle contains a ref state that never actually
499 # existed in reality (for example a new branch is pushed and then an old
500 # branch deleted afterwards -- the deletion would show up in the bundle
501 # because it will cause the original packed-refs file to be re-written, but
502 # the new branch creation will not unless we do another pack-refs which might
503 # lead to having in incomplete bundle). Therefore we want to keep a copy of
504 # the original packed-refs file around. We do the same thing for HEAD.
506 # It's possible that the "objects" subdirectory is a symbolic link.
507 # Git does support this. However, during the repacking process, new packs
508 # will be created in repack/alt/pack and then moved into objects/pack.
509 # In order for this to work seemlessly, they must both be on the same
510 # filesystem. But when objects (or even objects/pack) is a symbolic link they
511 # might not be. For this reason a "repack" subdirectory is created under
512 # objects/pack and the repack/alt/pack directory symbolicly linked to it.
514 # Git allows not just HEAD to be a symbolic-ref, but any ref anywhere in the
515 # refs namespace. We are concerned about ref name collisions and getting the
516 # right tag set to get an optimal pack. We can safely duplicate the ref space
517 # under refs/heads, refs/notes and refs/remotes without any risk of unwanted
518 # collisions and this will likely make over 99%+ of all symbolic refs found
519 # in the wild work properly. Girocco itself never creates any symbolic refs
520 # inside the refs namespace; this is a nod to simultaneously using a Girocco
521 # repository for other purposes.
522 make_repack_dir() {
523 ! [ -d repack ] || rm -rf repack
524 ! [ -d repack ] || { echo >&2 "[$proj] cannot remove repack subdirectory"; exit 1; }
525 [ -d objects/pack ] || mkdir -p objects/pack
526 ! [ -d objects/pack/repack ] || rm -rf objects/pack/repack
527 ! [ -d objects/pack/repack ] || { echo >&2 "[$proj] cannot remove objects/pack/repack subdirectory"; exit 1; }
528 mkdir repack repack/refs repack/alt objects/pack/repack
529 [ -d info ] || mkdir info
530 ln -s ../config repack/config
531 ln -s ../info repack/info
532 ln -s ../objects repack/objects
533 ln -s "$PWD/objects/pack/repack" repack/alt/pack
534 ln -s ../../refs repack/refs/refs
535 _lines=$(( $(LC_ALL=C wc -l <packed-refs) ))
536 cat HEAD >repack/HEAD.orig
537 >repack/packed-refs.extra
538 _xtralines=0
539 cat packed-refs >repack/packed-refs.orig
540 if [ $(LC_ALL=C wc -l <repack/packed-refs.orig) -ne "$_lines" ]; then
541 echo >&2 "[$proj] error: make_repack_dir failed original packed-refs line count sanity check"
542 exit 1
544 if [ "${cfg_fetch_stash_refs:-0}" = "0" ]; then
545 # migrate any refs/stash or refs/tgstash lines to repack/packed-refs.extra
546 <repack/packed-refs.orig awk -v xtra="repack/packed-refs.extra" '
547 BEGIN { peeling = 0 }
548 NR == 1 && /^#/ { print; next; }
549 peeling && /^\^/ { print >>xtra; next; }
550 /^[0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f]+ refs\/(stash|tgstash)(\/|$)/ {
551 peeling = 1
552 print >>xtra
553 next
555 { peeling = 0; print; }
556 ' >repack/packed-refs.new
557 _xtralines="$(( $(LC_ALL=C wc -l <repack/packed-refs.extra) + 0 ))"
558 _newlines="$(( $(LC_ALL=C wc -l <repack/packed-refs.new) + 0 ))"
559 if [ "$(( $_newlines + $_xtralines ))" -ne "$_lines" ]; then
560 echo >&2 "[$proj] error: make_repack_dir failed packed-refs.extra line count sanity check"
561 exit 1
563 mv -f repack/packed-refs.new repack/packed-refs.orig
564 _lines="$_newlines"
566 # Note: Git v1.5.0 introduced the "# pack-refs with:" header line for the packed-refs file
567 sed '/^# pack-refs/d; s, refs/, refs/!/,' <repack/packed-refs.orig >repack/packed-refs
568 nohead=
569 headref="$(git rev-parse --verify --quiet HEAD)" || :
570 if [ -n "$headref" ]; then
571 echo "$headref refs/!=/HEAD" >>repack/packed-refs
572 echo "$headref refs/heads/!" >>repack/packed-refs
573 nohead='\, refs/heads/!$,d; '
574 _lines=$(( $_lines + 2 ))
576 if [ $(( $(LC_ALL=C wc -l <repack/packed-refs) + 1 )) -ne "$_lines" ]; then
577 echo >&2 "[$proj] error: make_repack_dir failed packed-refs initial line count sanity check"
578 exit 1
580 sed -n "$nohead"'\, refs/heads/,p; \, refs/notes/,p; \, refs/remotes/,p' <repack/packed-refs.orig >>repack/packed-refs
581 _newlines="$(( $(LC_ALL=C wc -l <repack/packed-refs) ))"
582 if [ $(( $_newlines + 1 )) -lt "$_lines" ]; then
583 echo >&2 "[$proj] error: make_repack_dir failed packed-refs extra line count sanity check"
584 exit 1
586 _lines="$_newlines"
587 optref="$(git rev-list -n 1 --all 2>/dev/null)" || :
588 if [ -n "$optref" ]; then
589 echo "$optref refs/tags/!" >>repack/packed-refs
590 _lines=$(( $_lines + 1 ))
591 echo "$optref" >repack/HEAD
592 else
593 cat HEAD >repack/HEAD
595 if [ $(LC_ALL=C wc -l <repack/packed-refs) -ne "$_lines" ]; then
596 echo >&2 "[$proj] error: make_repack_dir failed packed-refs line count sanity check"
597 exit 1
601 # Remove any crud that's been left behind by interrupted operations
602 # that did not clean up after themselves
603 remove_crud() {
604 # Remove any existing FETCH_HEAD
605 # There can only be a FETCH_HEAD if we've been fetching, not if we've been
606 # receiving pushes (those never create a FETCH_HEAD).
607 # And if we're fetching because we're a mirror, we know we're not fetching right
608 # now since jobd.pl never runs a project's fetch simultaneously with its gc.
609 # Therefore any existing FETCH_HEAD is junk. And it may be many megabytes if
610 # there were a lot of refs.
611 rm -f FETCH_HEAD
613 # remove any existing pack_is_complete_test or repack subdirectories
614 # If either exists when this function is called it's crud
615 rm -rf pack_is_complete_test repack objects/pack/repack
617 # Remove any stale pack remnants that are more than an hour old.
618 # Stale pack fragments are defined as any pack-<sha1>.ext where .ext is NOT
619 # .pack AND the corresponding .pack DOES NOT exist. A bunch of stale
620 # pack-<sha1>.idx files without their corresponding .pack files are worthless
621 # and just waste space. Normally there shouldn't be any remnants but actually
622 # this can happen when things are interrupted at just the wrong time.
623 # Note that the objects/pack directory is created by git init and should
624 # always exist.
625 find -L objects/pack -maxdepth 1 -type f -mmin +60 -name "pack-$octet20*.?*" -print |
626 LC_ALL=C sed -e 's/^objects\/pack\/pack-//; s/\..*$//' | LC_ALL=C sort -u |
627 while read packsha; do
628 ! [ -e "objects/pack/pack-$packsha.pack" ] || continue
629 rm -f "objects/pack/pack-$packsha".?*
630 done
632 # Remove any stale tmp reflogs files that are more than one hour old.
633 # Since they are created only while the pre-receive hook is running and
634 # all it does is process a bunch of refs passed to it on standard input
635 # it's inconceivable that it would ever take as much as an hour to run.
636 if [ -d reflogs ]; then
637 find -L reflogs -maxdepth 1 -type f -mmin +60 -name "tmp_*" -exec rm -f '{}' + || :
640 # Remove any stale object tmp_obj_* files that are more than 3 hours old.
641 # Really these files should only exist very briefly so there shouldn't be any
642 # but things happen that can end up leaving them behind.
643 find -L objects/$octet -maxdepth 1 -type f -mmin +180 -name "tmp_obj_?*" -exec rm -f '{}' + 2>/dev/null || :
645 # Remove any stale pack .keep files that are more than 12 hours old.
646 # We don't do anything to create any permanent pack .keep files, so they must
647 # be remnants from some failed push or something. Removing the .keep will
648 # allow the pack to be properly repacked.
649 find -L objects/pack -maxdepth 1 -type f -mmin +720 -name "pack-$octet20*.keep" -exec rm -f '{}' + || :
651 # Remove any stale tmp_pack_*, tmp_idx_*, tmp_bitmap_*, packtmp-* or .tmp-*-pack* files
652 # that are more than 12 hours old.
653 find -L objects/pack -maxdepth 1 -type f -mmin +720 \( \
654 -name "tmp_pack_?*" -o -name "tmp_idx_?*" -o -name "tmp_bitmap_?*" -o \
655 -name "packtmp-?*" -o -name ".tmp-?*-pack*" \
656 \) -exec rm -f '{}' + || :
658 # Remove any stale incoming-* object quarantine directories that are
659 # more than 12 hours old. These are new with Git >= 2.11.0.
660 find -L objects -maxdepth 1 -type d -name 'incoming-?*' -mmin +720 \
661 -exec rm -rf '{}' + || :
663 # Remove any stale shallow_* files that are more than 12 hours old.
664 # These can be left behind by Git >= 1.8.4.2 and < 2.0.0 when a client
665 # requests a shallow clone. Also discard stale .refs-temp* and
666 # .refs-new* files at the same time.
667 find -L . -maxdepth 1 -type f -mmin +720 \( \
668 -name "shallow_?*" -o -name ".refs-temp*" -o -name ".refs-new*" \
669 \) -exec rm -f '{}' + || :
671 # Remove any stale *.temp files in the objects area that are more than 12 hours old.
672 # This can be stale sha1.temp, or stale *.pack.temp so we kill all stale *.temp.
673 find -L objects -type f -mmin +720 -name "*.temp" -exec rm -f '{}' + || :
675 # Remove any stale *.lock files in the htmlcache area that might have been left
676 # behind after an abnormal exit during an attempt to update a cached file and
677 # are more than 1 hour old.
678 ! [ -d htmlcache ] || find -L htmlcache -type f -mmin +60 -name "*.lock" -exec rm -f '{}' + || :
680 # Remove any stale git-svn temp files that are more than 12 hours old.
681 # The git-svn process creates temp files with random 10 character names
682 # in the root of $GIT_DIR. Unfortunately they do not have a recognizable
683 # prefix, so we just have to kill any files with a 10-character name. We
684 # do this only for git-svn mirrors. All characters are chosen from
685 # [A-Za-z0-9_] so we can at least check that and fortunately the only
686 # collision is 'FETCH_HEAD' but that shouldn't matter.
687 # There may also be temp files with a Git_ prefix as well.
688 if [ -n "$svn_mirror" ]; then
689 _randchar='[A-Za-z0-9_]'
690 _randchar2="$_randchar$_randchar"
691 _randchar4="$_randchar2$_randchar2"
692 _randchar10="$_randchar4$_randchar4$_randchar2"
693 find -L . -maxdepth 1 -type f -mmin +720 -name "$_randchar10" -exec rm -f '{}' + || :
694 find -L . -maxdepth 1 -type f -mmin +720 -name "Git_*" -exec rm -f '{}' + || :
697 # Remove any stale fast_import_crash_<pid> files that are more than 3 days old.
698 if [ -n "$gfi_mirror" ]; then
699 find -L . -maxdepth 1 -type f -mmin +4320 -name "fast_import_crash_?*" -exec rm -f '{}' + || :
702 # Remove any stale core or *.core or core.* files that are more than 3 days old.
703 find -L . -maxdepth 1 -type f -mmin +4320 \( -name "core" -o -name "*.core" -o -name "core.*" \) \
704 -exec rm -f '{}' + || :
708 ## Garbage Collection Types
710 ## There are two kinds of possible garbage collection (gc) operations:
712 ## 1. A normal, full gc
713 ## 2. A "mini" gc
715 ## If the full garbage collection interval has expired (or gc has never been
716 ## run), then a normal, full gc will take place. Otherwise, a "mini" gc will
717 ## take place if the file .needsgc exists.
719 ## A "mini" gc is similar to "git gc --auto" in that it may not end up actually
720 ## doing anything unless the right conditions are present so it's not a burden
721 ## to run it often. If the file .needsgc exists, a "mini" gc will occur at
722 ## the next opportunity.
724 ## See the docs/technical/gc.txt and docs/technical/gc-mini.txt files for more
725 ## of the gory details of how garbage collection is performed.
727 ## Note, however, that the .nogc file suppresses ALL gc activity (normal or mini).
730 proj="${1%.git}"
731 shift
732 cd "$cfg_reporoot/$proj.git"
733 [ -d objects/pack ] || { rm -f gfi-packs; mkdir -p objects/pack; }
734 mirror_url="$(get_mirror_url)" || :
735 svn_mirror=
736 ! is_svn_mirror_url "$mirror_url" || svn_mirror=1
737 gfi_mirror=
738 if [ -f gfi-packs ] && [ -s gfi-packs ] && is_gfi_mirror_url "$mirror_url"; then
739 gfi_mirror=1
742 # If git config --bool --get girocco.redelta is explicitly false then automatic
743 # redelta when there are less than $var_redelta_threshold objects will be suppressed.
744 # On the other hand, if git config --get girocco.redelta is "always" then, on a full
745 # gc only, for the final repack, deltas will always be recomputed.
746 # This can be set on a per-project basis to avoid unusual pathological gc behavior.
747 # Setting this will hurt efficiency of the affected repository.
748 # Note that fast-import packs ALWAYS get new deltas regardless of this setting.
749 noreusedeltaopt="--no-reuse-delta"
750 [ "$(git config --bool --get girocco.redelta 2>/dev/null || :)" != "false" ] || noreusedeltaopt=
751 alwaysredelta=
752 [ "$(git config --get girocco.redelta 2>/dev/null || :)" != "always" ] || alwaysredelta=1
754 # Extract any -f or -F or --no-reuse-object or --no-reuse-delta options
755 # to be compatible with the old and new gc.sh versions and avoid ugly argument
756 # duplication in process lists at the same time
757 # Any options found will override the "girocco.redelta" setting
758 recompress=
759 idx=$#
760 while [ $idx -gt 0 ]; do
761 idx=$(( $idx - 1 ))
762 opt="$1"
763 shift
764 case "$opt" in
765 -f|--no-reuse-delta)
766 alwaysredelta=1
767 continue
769 -F|--no-reuse-object)
770 alwaysredelta=1
771 recompress=1
772 continue
774 -?*)
777 printf >&2 '%s\n' "bad non-option argument: $opt"
778 echo >&2 "(Did you perhaps intend to use a --xxx=yyy form?)"
779 exit 1
780 esac
781 [ -z "$opt" ] || set -- "$@" "$opt"
782 done
783 if [ -n "$alwaysredelta" ]; then
784 noreusedeltaopt="--no-reuse-delta"
785 [ -z "$recompress" ] || noreusedeltaopt="--no-reuse-object"
788 trap 'e=$?; rm -f .gc_in_progress; if [ $e != 0 ]; then echo "gc failed dir: $PWD" >&2; fi' EXIT
789 trap 'exit 130' INT
790 trap 'exit 143' TERM
792 # date -R is linux-only, POSIX equivalent is '+%a, %d %b %Y %T %z'
793 datefmt='+%a, %d %b %Y %T %z'
795 isminigc=
796 if [ "${force_gc:-0}" = "0" ] && check_interval lastgc $cfg_min_gc_interval; then
797 if [ -e .needsgc ]; then
798 isminigc=1
799 else
800 progress "= [$proj] garbage check skip (last at $(config_get lastgc))"
801 exit 0
804 if [ -e .nogc ]; then
805 progress "x [$proj] garbage check disabled"
806 exit 0
808 if [ -z "$isminigc" ] && [ -e .delaygc ] && [ -e .needsgc ]; then
809 # Eligible for a full gc but .delaygc is set so it would be skipped
810 # However .needsgc is also set so transform it into a mini instead
811 isminigc=1
812 progress "~ [$proj] garbage check delayed but checking mini because .needsgc"
815 if [ -n "$isminigc" ]; then
816 # Perform a "mini" gc
817 # Note that .delaygc is ignored here as that's only intended for full gc
818 lock_gc
819 rm -f .allowgc .needsgc
820 rm -f objects/pack/pack-*_[rful].keep
821 remove_crud
822 coalesce_reflogs
823 prune_reflogs
824 compact_reflogs
825 maintain_auto_gc_hack
826 generate_auto_gc_update
827 miniactive=
828 if [ -f .needspack ]; then
829 miniactive=1
830 progress "+ [$proj] mini garbage check ($(date))"
831 make_needs_pack
833 if [ -z "$cfg_delay_gfi_redelta" ] && [ -n "$gfi_mirror" ]; then
834 # $Girocco::Config::delay_gfi_redelta is false, force redeltification now
835 if [ -z "$miniactive" ]; then
836 miniactive=1
837 progress "+ [$proj] mini garbage check ($(date))"
839 repack_gfi_packs
841 if lotsa_loose_objects; then
842 if [ -z "$miniactive" ]; then
843 miniactive=1
844 progress "+ [$proj] mini garbage check ($(date))"
846 pack_loose_objects
848 # If there aren't at least 10 non-keep, non-bitmap, non-bndl packs then
849 # don't actually process them yet
850 lpo="--exclude-no-idx --exclude-keep --exclude-bitmap --exclude-bndl --quiet"
851 packcnt="$(list_packs --count $lpo objects/pack)" || :
852 if [ "${packcnt:-0}" -ge 10 ]; then
853 if [ -z "$miniactive" ]; then
854 miniactive=1
855 progress "+ [$proj] mini garbage check ($(date))"
857 if [ -n "$gfi_mirror" ]; then
858 repack_gfi_packs
859 packcnt="$(list_packs --count $lpo objects/pack)" || :
861 # if repack_gfi_packs dropped the pack count to < 10 don't combine
862 if [ "${packcnt:-0}" -ge 10 ]; then
863 combine_small_packs
864 combine_small_loose_packs
865 packcnt="$(list_packs --count $lpo objects/pack)" || :
867 # if we still have more than 10 packs trigger a full gc
868 if [ "${packcnt:-0}" -ge 10 ]; then
869 # We shouldn't be in a .delaygc state at this point, but if
870 # we are then nuke it because we really need a full gc now
871 rm -f .delaygc
872 git config --unset gitweb.lastgc
873 rm -f "$lockf"
874 git update-server-info # just in case
875 progress "- [$proj] mini garbage check triggering full gc too many packs ($(date))"
876 exit 0
879 rm -f "$lockf"
880 if [ -n "$miniactive" ]; then
881 git update-server-info
882 progress "- [$proj] mini garbage check ($(date))"
883 else
884 progress "= [$proj] mini garbage check nothing but crud removal to do ($(date))"
886 exit 0
889 # Avoid unnecessary garbage collections:
890 # 1. If lastreceive is set and is older than lastgc
891 # -AND-
892 # 2. We are not a fork (! -s alternates) -OR- lastparentgc is older than lastgc
894 # If lastgc is NOT set or lastreceive is NOT set we MUST run gc
895 # If we are a fork and lastparentgc is NOT set we MUST run gc
897 # If the repo is dirty after removing any crud we MUST run gc
899 gcstart="$(date "$datefmt")"
900 skipgc=
901 isfork=
902 ! [ -s objects/info/alternates ] || isfork=1
903 lastparentgcsecs=
904 [ -z "$isfork" ] || lastparentgcsecs="$(config_get_date_seconds lastparentgc)" || :
905 lastreceivesecs=
906 if lastreceivesecs="$(config_get_date_seconds lastreceive)" &&
907 [ "${force_gc:-0}" = "0" ] &&
908 lastgcsecs="$(config_get_date_seconds lastgc)" &&
909 [ $lastreceivesecs -lt $lastgcsecs ]; then
910 # We've run gc since we last received, so maybe we can skip,
911 # check if not fork or fork and lastparentgc < lastgc
912 if [ -n "$isfork" ]; then
913 if [ -n "$lastparentgcsecs" ] &&
914 [ $lastparentgcsecs -lt $lastgcsecs ]; then
915 # We've run gc since our parent ran gc so we can skip
916 skipgc=1
918 else
919 # We don't have any alternates (we're not a forK) so we can skip
920 skipgc=1
924 # Prevent any other simultaneous gc operations
925 lock_gc
927 # At this point, if .allowgc or .gc_failed exists, it's now crud to be removed
928 rm -f .allowgc .gc_failed
930 # Ideally we would do this in post-receive, but that would mean duplicating the
931 # logic so it's available in the chroot jail and that's highly undesirable
932 # Instead, since the first gc will be triggered immediately following the first
933 # push, we do the check here as it's quick and harmless if HEAD is already valid
934 check_and_set_head || :
936 # Always get rid of crud
937 remove_crud
939 # Always perform reflogs maintenance
940 coalesce_reflogs
941 prune_reflogs
942 compact_reflogs
944 # Always maintain auto gc hack
945 maintain_auto_gc_hack
946 generate_auto_gc_update
948 # Run 'git svn gc' now for svn mirrors
949 if [ -n "$svn_mirror" ]; then
950 git svn gc || :
953 # Skip the actual gc if .delaygc is set
954 if [ -e .delaygc ]; then
955 progress "x [$proj] garbage check delayed (except for crud removal)"
956 rm -f "$lockf"
957 exit 0
960 # Do not skip gc if the repo is dirty
961 if [ -n "$skipgc" ] && ! is_dirty; then
962 progress "= [$proj] garbage check nothing but crud removal to do ($(date))"
963 config_set lastgc "$gcstart"
964 rm -f "$lockf"
965 exit 0
968 bumptime=
969 if [ -n "$isfork" ] && [ -z "$lastparentgcsecs" ]; then
970 # set lastparentgc and then update gcstart to be at least 1 second later
971 config_set lastparentgc "$gcstart"
972 bumptime=1
974 if [ -z "$lastreceivesecs" ]; then
975 # set lastreceive and then update gcstart to be at least 1 second later
976 config_set lastreceive "$gcstart"
977 bumptime=1
979 if [ -n "$bumptime" ]; then
980 sleep 1
981 gcstart="$(date "$datefmt")"
984 progress "+ [$proj] garbage check ($(date))"
986 newdeltas=
987 [ -z "$alwaysredelta" ] || newdeltas="$noreusedeltaopt"
988 if [ -z "$newdeltas" ] && [ -n "$gfi_mirror" ]; then
989 if [ $(list_packs --exclude-no-idx --count objects/pack) -le \
990 $(list_packs --exclude-no-idx --count --quiet --only gfi-packs) ]; then
991 # Don't bother with repack_gfi_packs since everything's being repacked
992 newdeltas="--no-reuse-delta"
995 if [ -z "$newdeltas" ] && [ -n "$noreusedeltaopt" ] &&
996 [ $(list_packs --all --exclude-no-idx --count-objects objects/pack) -le $var_redelta_threshold ]; then
997 # There aren't enough objects to worry about so just redelta to get the best pack
998 newdeltas="--no-reuse-delta"
1000 if [ -z "$newdeltas" ]; then
1001 # Since we're not going to recompute deltas overall, we need to do the
1002 # "mini" maintenance so that we can get more optimal deltas
1003 [ -z "$noreusedeltaopt" ] || make_needs_pack
1004 repack_gfi_packs
1005 force_single_pack_redelta=
1006 [ -n "$gfi_mirror" ] || [ -n "$svn_mirror" ] || force_single_pack_redelta=1
1007 [ -z "$noreusedeltaopt" ] || combine_small_packs $force_single_pack_redelta
1008 [ -z "$noreusedeltaopt" ] || combine_small_loose_packs $force_single_pack_redelta
1012 ## Safe Pruning In Forks
1014 ## We are about to perform garbage collection. We do NOT use the "git gc" or
1015 ## the "git repack" commands directly as they do not provide enough control over
1016 ## the fine details. However, we DO maintain a "gc.pid" file during our garbage
1017 ## collection so that a simultaneous "git gc" by an administrator will be
1018 ## blocked (and similarly we refuse to start garbage collection if we cannot
1019 ## create the "gc.pid" file).
1021 ## When we say "gc" in the below description we are referring to our "gc.sh"
1022 ## script, NOT the "git gc" command.
1024 ## If the project we are running garbage collection (gc) on has any forks we
1025 ## must be careful not to remove any objects that while no longer referenced by
1026 ## this project (the parent) are still referenced by one or more forks (the
1027 ## children) otherwise the children will become corrupt and we can't abide
1028 ## corrupt children.
1030 ## One way to accomplish this is to simply hard-link all currently existing
1031 ## loose objects and packs in the parent into all the children that refer to the
1032 ## parent (via a line in their objects/info/alternates file) before beginning
1033 ## the gc operation and then relying on a subsequent gc in the child to clean up
1034 ## any excess objects/packs. We used to use this strategy but it's very
1035 ## inefficient because:
1037 ## 1. The disk space used by the old pack(s)/object(s) will not be reclaimed
1038 ## until all children (and their children, if any) run gc by which time
1039 ## it's quite possible the topmost parent will have run gc again and
1040 ## hard-linked yet another old pack down to its children (not to mention
1041 ## loose objects).
1043 ## 2. When using the "-A" option with "git repack", any new objects in the
1044 ## parent that are not referenced by children will continually get
1045 ## exploded out of the hard-linked pack in the children whenever the
1046 ## children run gc.
1048 ## 3. To avoid suboptimal and/or unnecessarily many packs being hard-linked
1049 ## into child forks, we must run the "mini" gc maintenance before we
1050 ## perform the hard-linking into the children which provides yet another
1051 ## source of inefficiency.
1053 ## While we were still using the "-A" option to "git repack" (that was not
1054 ## always the case) to guarantee we can access old ref values for long enough
1055 ## to send out a meaningful mail.sh notification, another, more efficient,
1056 ## option became available to prevent corruption of child forks that continue
1057 ## to refer to objects that are no longer reachable from any ref in the parent.
1059 ## The only things that need be copied (or hard-linked) into the child fork(s)
1060 ## are those objects that have become unreachable from any ref in the parent.
1062 ## When we were using the "git repack -A -d" + "git prune --expire=1.day.ago"
1063 ## technique, the only objects that could ever be removed were loose objects
1064 ## that "git prune" determined were expired. In that case, loose objects were
1065 ## all that need be hard-linked down to child forks in order to avoid
1066 ## corruption of any child fork(s).
1068 ## The "git repack -A -d" + "git prune --expire=1.day.ago" + hard-linking loose
1069 ## objects to child forks technique remains fundamentally sound from the
1070 ## perspective of supporting simultaneous gc and push and keeping newly
1071 ## unreachable objects around long enough to be sure we can send out meaningful
1072 ## ref change notifications and never corrupting any child forks and never
1073 ## persisting the lifetime of large old packs containing mostly duplicate or
1074 ## unreachable objects as gc percolates through a project's entire fork tree.
1076 ## However, that technique suffers from one potential prodigious pitfall.
1078 ## Unreachable objects come flying out of their packs to splatter all over the
1079 ## objects subdirectories possibly creating a huge, inefficient mess.
1081 ## Often this is not an issue. Even with a lot of rebasing going on, usually
1082 ## the only objects that will splatter are some commits, trees and the odd blob
1083 ## here and there. Not enough to be overly concerned about.
1085 ## However, for the reppository that frequently experiences a lot of non-fast-
1086 ## forward updates and/or outright ref deletion, the number of objects suddenly
1087 ## popping out of their packs at "git repack -A -d" time can be overwhelming.
1089 ## To avoid this issue we now use a four phase pack creation strategy.
1090 ## This will result in creation of up to four packs (instead of at most one).
1092 ## I. A complete pack (with bitmaps if appropriate) gets created including
1093 ## only "reachable" objects from all refs/... refs plus HEAD. This will
1094 ## also serve as the virtual bundle for the repository.
1096 ## II. A pack of recently-became-unreachable objects and friends is created.
1097 ## (The "friends" are ref logs, linked working tree HEADs and indicies.)
1098 ## Because both the pre-receive and update.sh script record all ref
1099 ## changes we can easily choose the cut off point for "recently".
1100 ## It is only the fact we maintain those logs in the reflogs subdirectory
1101 ## that allows this step to be possible.
1103 ## III. If the repository has any forks with a non-zero length alternates file,
1104 ## yet another pack of "--keep-unreachable" objects is generated that will
1105 ## not actually be kept in the parent, but hard-linked into all the forks.
1107 ## IV. Finally, after running "git prune-packed", any remaining loose objects
1108 ## are migrated into a pack of their own.
1110 ## We then remove any non-.keep packs that existed before we started the
1111 ## process being careful to keep any same-pack pushes for the "Push Pack Redux"
1112 ## race condition (see README-GC).
1114 ## By using "git pack-objects" directly we are able to accomplish this with
1115 ## very little additional effort.
1117 ## The packs produced by (III) are treated almost like ".keep" packs by child
1118 ## forks in that the objects in them are never repacked into any other
1119 ## "--keep-unreachable" packs (but they can migrate into phase I or II packs)
1120 ## and those phase III packs are then hard-linked into any grandchild forks.
1122 ## This avoids the space explosion that could occur if each fork level ended
1123 ## up duplicating the "--keep-unreachable" pack space by repacking those
1124 ## objects (essentially breaking the hard-link to the single copy of those
1125 ## objects).
1127 ## While it is true that each level of forks could potentially add yet another
1128 ## phase III pack to be hard-linked down to its children, such packs will only
1129 ## include unreachable objects not already in any phase III packs that were
1130 ## received from the parent.
1132 ## The space for the phase III packs will not be reclaimed until the gc
1133 ## finishes percolating through the entire "fork tree" of a project.
1135 ## This is not much different than the "git repack -A -d" situation where
1136 ## all the loose objects are hard-linked down into child forks. In that
1137 ## case forks that actually need any of those objects could gradually reduce
1138 ## the number of objects hard-linked into deeper fork levels.
1140 ## The difference with a phase III "--keep-unreachable" pack is that there
1141 ## cannot be any gradual reduction like that since it would require repacking
1142 ## the pack and breaking the hard-link thereby increasing storage space. The
1143 ## storage will instead always be reclaimed all at once when all of the
1144 ## projects in the "fork tree" complete their gc.
1146 ## However, the belief is that the huge space win by having all the
1147 ## unreachable objects packed up together far eclipses (when many objects are
1148 ## involved, the single-pack version can end up using 1/20th or less of the
1149 ## disk space compared to having them all as loose objects) any brief minor
1150 ## space savings that might occur under the "git repack -A -d" loose object
1151 ## system prior to the gc collection completing for all the projects in the
1152 ## "fork tree".
1156 ## utility functions
1159 make_packs_ugw() {
1160 find -L "$1" -maxdepth 1 -type f ! -perm -ug+w \
1161 -name "pack-$octet20*.pack" -exec chmod ug+w '{}' + || :
1162 } 2>/dev/null
1164 get_index_tree() {
1165 if [ -s "$1" ]; then
1166 GIT_INDEX_FILE="$1"
1167 export GIT_INDEX_FILE
1168 git write-tree 2>/dev/null || :
1169 unset GIT_INDEX_FILE
1173 get_detached_head() {
1174 if [ -s "$1" ] && read -r _head <"$1" 2>/dev/null; then
1175 case "$_head" in $octet20*)
1176 echo "$_head"
1177 esac
1181 # compute_extra_reachables
1182 # create lines suitable for a packed-refs file mentioning all the
1183 # other refs we might like to keep.
1184 # the current directory MUST be set to the repository's --git-dir
1185 # the following are included:
1186 # * refs mentioned in repack/packed-refs.extra (if it exists)
1187 # * refs mentioned in reflogs/... files
1188 # * tree(s) created from index file(s)
1189 # * detached linked working tree heads
1190 # Resulting objects are tested for existence and uniqified then output
1191 # one per line under a refs/z* namespace
1192 compute_extra_reachables() {
1194 if [ -s repack/packed-refs.extra ]; then
1195 LC_ALL=C sed <repack/packed-refs.extra -n \
1196 -e 's/^\([0-9A-Fa-f][0-9A-Fa-f]*\).*$/\1/p' \
1197 -e 's/^\^\([0-9A-Fa-f][0-9A-Fa-f]*\).*$/\1/p'
1199 digits8='[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]'
1200 find -L reflogs -mindepth 1 -maxdepth 1 -type f -name "$digits8*" -exec gzip -c -d -f '{}' + |
1201 awk '{print $2; print $3}'
1202 ! [ -f index ] || get_index_tree index
1203 if [ -d worktrees ]; then
1204 find -L worktrees -mindepth 2 -maxdepth 2 -name HEAD -type f -print |
1205 while read -r lwth; do
1206 get_detached_head "$lwth"
1207 get_index_tree "${lwth%HEAD}index"
1208 done
1210 } | LC_ALL=C sort -u |
1211 git cat-file ${var_have_git_260:+--buffer} --batch-check"${var_have_git_185:+=%(objectname)}" |
1212 awk '!/missing/ {num++; print $1 " " "refs/" substr("zzzzzzzzzzzz", 1, length(num)) "/" num}'
1216 ## main gc logic
1219 # Everything else is more efficient if we do this first
1220 # The "--prune" option is the default since v1.5.0 but it serves as "documentation" here
1221 git pack-refs --all --prune
1222 [ -e packed-refs ] || >>packed-refs # should never happen...
1224 # If we have a logs directory or a worktrees directory expire the ref logs now
1225 # Note that Git itself does not use either --rewrite or --updateref, so neither do we
1226 ! [ -d logs ] && ! [ -d worktrees ] || eval git reflog expire --all "${quiet:+>/dev/null 2>&1}" || :
1228 make_repack_dir
1229 ! [ -e .gc_failed ] || exit 1
1230 rm -f .gc_in_progress # make sure
1231 touch .gc_in_progress # it's truly fresh
1232 rm -f bundles/* objects/pack/pack-*.bndl
1233 # These only exist for a brief time before the packs loose their _f suffix
1234 # "Push Pack Redux" does not apply to these since they were only ever present with _f
1235 rm -f objects/pack/pack-*_f.keep
1236 # This is perhaps a bit aggressive in that if we're suffering from "Push Pack Redux"
1237 # and somehow we get run again immediately after the run where "Push Pack Redux" happened
1238 # and we have garbage collection forced, there's just the barest, almost negligible,
1239 # possibility that the "Push Pack Redux" ref updates _still_ have not happened and we
1240 # should not be removing _r .keep files. None of the normal Girocco processing can
1241 # cause this. The second run of this script would have to use the force gc option
1242 # for it to even be possible in the first place. What's much more likely is that
1243 # the initial run of this script was somehow interrupted in the middle before it
1244 # could get rid of the _r .keep file itself in which case it's better to get rid of
1245 # it now to avoid keeping something around that would perturb our nice and neat gc
1246 rm -f objects/pack/pack-*_r.keep
1247 # We will add .keep files for _u and _l packs if and when we run phase III
1248 # Otherwise they need to not have any .keep files during phases I and II
1249 rm -f objects/pack/pack-*_[ul].keep
1251 # We need to make sure that any non-Girocco (barely tolerated) Git object creation
1252 # activity will be able to "freshen" the pack containing a pre-existing object
1253 # that's being written. This really should not be necessary as the pre-receive
1254 # hook should make sure this takes place for any incoming pushes.
1255 # However, do it here anyway just in case.
1256 make_packs_ugw objects/pack
1258 # This is only effective with Git v2.3.5 and later and it will only matter when
1259 # we are using one of the "internal_rev_list" modes of pack-objects
1260 # (the combine-packs.sh script never uses any of those modes)
1261 # The "git repack" and "git prune" commands always set this internally themselves
1262 # It makes no difference if there's no repository corruption
1263 GIT_REF_PARANOIA=1 && export GIT_REF_PARANOIA
1265 # All of the options we might want to use with pack-objects were supported
1266 # at some point prior to Git version v1.6.6 which is the minimum version that
1267 # Girocco now requires. Except for one (--use-bitmap-index). Several of them
1268 # are "boiler plate" options we always want to use so we bundle them up here.
1269 pkopt="--delta-base-offset --keep-true-parents --non-empty --all-progress-implied"
1270 # We want to use --include-tag, but before Git v2.10.1 it would leave out
1271 # "middle" tags (e.g. a tag of a tag of a commit would omit the tagged tag)
1272 # See http://repo.or.cz/git.git/b773ddea2cd3b08c for details
1273 # ("pack-objects: walk tag chains for --include-tag", 2016-09-07, v2.10.1)
1274 # This is not a free check as it matches all refs against refs/tags/ then
1275 # peels all the annotated tags and checks for inclusion. The situation in
1276 # which it would add a tag that was not already included by a reachability
1277 # trace that included tag starting points can only occur if a new tag gets
1278 # pushed during gc pointing to something that would have been packed anyway.
1279 # But, it could happen and, really, compared to gc as a whole it's not that
1280 # expensive to perform (provided we do not get an unconnected pack).
1281 [ -z "$var_have_git_2101" ] || pkopt="$pkopt --include-tag"
1282 pkopt="$pkopt ${quiet:---progress} $packopts"
1284 # The git pack-objects command only supports bitmaps if all objects are being
1285 # packed (the "--all" option) and the "--stdout" option is NOT being used.
1286 # Additionally, while packing, if any encountered reachable objects are
1287 # determined to be "not wanted" then no bitmap index will be written anyway.
1288 # While it is theoretically possible that a project with a non-empty alternates
1289 # file ends up packing all objects (because it does not actually use any of the
1290 # objects found in the alternates), it's very unlikely. And, in the unlikely
1291 # event that did occur, clients would see a message about only using one bitmap
1292 # because Git can only use one bitmap at a time and at least one of the
1293 # alternates is bound to have a bitmap. Therefore if we see a non-empty
1294 # alternates file, we disable writing bitmaps which avoids the warning and any
1295 # possibility of a client warning as well. Also if we are running anything
1296 # before Git v2.1.0 (the effective version for repack.writeBitmaps=true) then
1297 # we also always disable bitmap writing.
1298 wbmopt=
1299 [ -z "$var_have_git_210" ] || wbmopt="--write-bitmap-index"
1300 # More recent versions of pack-objects have optimizations when not using the
1301 # --local option. If we do not have any alternates it's a pointless option.
1302 # If we do have alternates we need to skip writing a bitmap and we cannot
1303 # have a bundle since it must contain all objects.
1304 if [ -n "$isfork" ]; then
1305 lclopt="--local"
1306 wbmopt=
1307 makebndl=
1308 else
1309 lclopt=
1310 makebndl=1
1314 ## Phase I
1317 wbmstr=
1318 [ -n "$wbmopt" ] || wbmstr=" (bitmaps disabled)"
1319 progress "~ [$proj] running primary full gc pack-objects$wbmstr ($(date))"
1321 gotforks=
1322 ! has_forks_with_alternates "$proj" || gotforks=1
1324 # To avoid "Push Pack Redux" (see README-GC), after collecting the initial
1325 # preexisting non-keep pack list, we rename them so that an incoming push
1326 # pack cannot possibly experience a pack name collision. Git does not require
1327 # use of the "default" pack names, simply that the proper extensions are used.
1328 # We rename to insert an "_r" just before the extension to avoid "Push Pack Redux"
1329 # name collisions. Later on we may create an "unreachable" pack for hard-linking
1330 # down into forks and it will have an "_u" inserted just before its extension.
1331 packlist="$(list_packs -C objects/pack --all --exclude-no-idx --exclude-keep --quiet .)" || :
1332 oldpacks=
1333 for oldpack in $packlist; do
1334 oldpack="${oldpack%.pack}"
1335 [ -f "objects/pack/$oldpack.pack" ] || {
1336 echo >&2 "[$proj] unable to list old pack files"
1337 exit 1
1339 case "$oldpack" in pre-auto-gc-[12])
1340 # we never disturb pre-auto-gc-1 or pre-auto-gc-2 packs
1341 continue
1342 esac
1343 oldpackhex="${oldpack#pack-}"
1344 if [ "${oldpackhex#*[!0-9a-fA-F]}" != "$oldpackhex" ]; then
1345 # names not exclusively hexadecimal do not need renaming
1346 case "$oldpack" in
1347 pack-$octet20*_l)
1348 # _l packs are treated like still-unpacked loose objects
1349 continue;;
1350 *_f)
1351 # _f packs can only be left over from a previously interrupted gc;
1352 # they need to be renamed to _r now so they're not confused with
1353 # any freshly generated "final" packs (and we already removed
1354 # any pre-existing *_f.keep files so we're good to go)
1357 oldpacks="${oldpacks:+$oldpacks }$oldpack"
1358 continue;;
1359 esac
1361 rename_pack "objects/pack/$oldpack" "objects/pack/${oldpack%_f}_r" || {
1362 echo >&2 "[$proj] unable to rename old pack files"
1363 exit 1
1365 # If the oldpack has a .keep now it means a "Push Pack Redux" is actually
1366 # in progress at this moment and we need to .keep the renamed pack,
1367 # otherwise no "Push Pack Redux" has started yet or it has already finished.
1368 # In either case we're okay because if it's just finished then all ref
1369 # changes have already been made so we don't need a .keep and we will
1370 # see the ref changes and grab all the objects via a reachability trace.
1371 # If it hasn't started yet that's okay because we're done moving that
1372 # name so a complete pack will appear under the old name that we'll
1373 # leave alone.
1374 if [ -f "objects/pack/$oldpack.keep" ]; then
1375 echo "Push Pack Redux" >"objects/pack/${oldpack%_f}_r.keep"
1376 else
1377 oldpacks="${oldpacks:+$oldpacks }${oldpack%_f}_r"
1379 done
1381 # We wish to keep deltas from our last full pack so if we're not redeltaing
1382 # then make sure the .pack associated with the .bitmap has a newer mod time
1383 # (If there is no .bitmap then touch the pack with the most objects instead.)
1384 if [ -z "$newdeltas" ]; then
1385 bmpack="$(list_packs --exclude-no-bitmap --exclude-no-idx --max-matches 1 objects/pack)"
1386 [ -n "$bmpack" ] || bmpack="$(list_packs --exclude-no-idx --max-matches 1 --object-limit -1 --include-boundary objects/pack)"
1387 if [ -n "$bmpack" ] && [ -f "$bmpack" ] && [ -s "$bmpack" ]; then
1388 sleep 1
1389 touch -c "$bmpack" 2>/dev/null || :
1390 # We must touch .gc_in_progress here to avoid $bmpack looking
1391 # like it's been "freshened" when redundant packs are removed
1392 # It's okay if they have the same mod time, but POSIX does not
1393 # guarantee an ordering for the "touching" that occurs which is
1394 # why this must be a separate command but needs no "sleep 1"
1395 touch .gc_in_progress
1399 # Now we need to make sure that any "freshening" that takes place will actually
1400 # result in a "newer" modification time than the .gc_in_progress file now has
1401 sleep 1
1403 # We run git pack-objects from the repack subdirectory so we can force
1404 # optimized packs to be generated even for repositories that do not have any
1405 # tagged commits
1406 packs="$(git --git-dir=repack pack-objects </dev/null \
1407 $pkopt --all $newdeltas $lclopt ${wbmopt:---honor-pack-keep} "$@" repack/alt/pack/pack)"
1408 vcnt packcnt $packs
1409 [ $packcnt -eq 1 ] || makebndl=
1412 ## Phase II
1415 progress "~ [$proj] running supplementary gc pack-objects ($(date))"
1417 # Add the "supplementary" refs
1418 compute_extra_reachables >>repack/packed-refs
1420 # Subtract the primary refs
1421 GIT_ALTERNATE_OBJECT_DIRECTORIES="$PWD/repack/alt"
1422 export GIT_ALTERNATE_OBJECT_DIRECTORIES
1424 # For this one we MUST use --local and MUST NOT use --write-bitmap-index
1425 # However, if there is a "logs" subdirectory we need to use --reflog
1426 # We do add it, just in case, if the linked working trees dir is present
1427 # We do not add --indexed-objects as that requires v2.2.0 and it's unclear
1428 # if it properly includes linked working tree index files or not. The
1429 # above compute_extra_reachables has already included all index trees (thereby
1430 # providing proper --indexed-objects support for all Git versions) making the
1431 # option completely unnecessary.
1432 rflopt=
1433 ! [ -d logs ] && ! [ -d worktrees ] || rflopt=--reflog
1434 spacks="$(git --git-dir=repack pack-objects </dev/null \
1435 $pkopt --honor-pack-keep --all $rflopt $newdeltas --local "$@" repack/alt/pack/pack)"
1438 ## Phase III
1441 # There's nothing to do for Phase III unless we have forks that refer to our
1442 # project from their alternates file
1443 hlpacks=
1444 upacks=
1445 if [ -n "$gotforks" ]; then
1447 progress "~ [$proj] running keep-unreachable gc pack-objects for forks ($(date))"
1449 # If we are a fork, any pre-existing _u packs need to have a .keep
1450 # for this phase and be added to the hlpacks list otherwise (we are
1451 # not a fork) pre-existing _u packs are anomalies to be treated like
1452 # regular non-_u packs
1453 if [ -n "$isfork" ]; then
1454 for upack in $(find -L objects/pack -mindepth 1 -maxdepth 1 -name "pack-$octet20*_[ul].pack" -print); do
1455 upack="${upack%.pack}"
1456 [ -e "$upack.keep" ] || echo "unreachable" >"$upack.keep"
1457 case "$upack" in *_l);;*)
1458 hlpacks="${hlpacks:+$hlpacks }${upack#objects/pack/pack-}"
1459 esac
1460 done
1462 # Using either --no-reuse-delta or --no-reuse-object together with the
1463 # --keep-unreachable option is a very, very, very bad idea when good
1464 # packs are the desired outcome. If newdeltas are being generated
1465 # then we pack to a temp name, and use combine-packs.sh to get a better
1466 # pack as the result to avoid making a bad --keep-unreachable pack
1467 pfx=
1468 [ -z "$newdeltas" ] || pfx="ku"
1469 upacks="$(git --git-dir=repack pack-objects </dev/null \
1470 $pkopt --honor-pack-keep --all $rflopt --keep-unreachable --local "$@" repack/alt/pack/${pfx}pack)"
1471 if [ -n "$upacks" ] && [ -n "$newdeltas" ]; then
1472 progress "~ [$proj] rebuilding keep-unreachable pack deltas"
1473 oldupacks="$upacks"
1474 upacks="$(
1475 printf "repack/alt/pack/${pfx}pack-%s.pack\n" $oldupacks |
1476 run_combine_packs --names --weak-naming --non-empty --all-progress-implied ${quiet:---progress} \
1477 $packopts $newdeltas "$@" repack/alt/pack/pack)"
1478 eval rm -f "$(printf \""repack/alt/pack/${pfx}pack-%s.*"\"" " $oldupacks)"
1480 for upack in $upacks; do
1481 rename_pack "repack/alt/pack/pack-$upack" "repack/alt/pack/pack-${upack}_u"
1482 done
1483 rm -f objects/pack/pack-*_[ul].keep
1484 [ -z "$hlpacks" ] && [ -z "$upacks" ] ||
1485 progress "~ [$proj] hard-linking keep-unreachable pack(s) into immediate child forks"
1487 # We have to update the lastparentgc time in the child forks even if they do not get any
1488 # new "unreachable packs" because they need to run gc just in case the parent now has some
1489 # objects that used to only be in the child so they can be removed from the child.
1490 # For example, a "patch" might be developed first in a fork and then later accepted into
1491 # the parent in which case the objects making up the patch in the child fork are now
1492 # redundant (since they're now in the parent as well) and need to be removed from the
1493 # child fork which can only happen if the child fork runs gc.
1494 lastparentgc="$(date "$datefmt")"
1496 # It is enough to copy objects just one level down and get_repo_list
1497 # takes a regular expression (which is automatically prefixed with '^')
1498 # so we can easily match forks exactly one level down from this project
1499 forkdir="$proj"
1500 get_repo_list "$forkdir/[^/:][^/:]*:" |
1501 while read fork; do
1502 # Ignore forks that do not exist or are symbolic links
1503 ! [ -L "$cfg_reporoot/$fork.git" ] && [ -d "$cfg_reporoot/$fork.git" ] ||
1504 continue
1505 # Or do not have a non-zero length alternates file
1506 [ -s "$cfg_reporoot/$fork.git/objects/info/alternates" ] ||
1507 continue
1508 runupdate=
1509 # Match hlpacks in parent project if any
1510 if [ -n "$hlpacks" ]; then
1511 mkdir -p "$cfg_reporoot/$fork.git/objects/pack"
1512 eval ln -f "$(printf '"objects/pack/pack-%s.pack" ' $hlpacks)" \
1513 "$(printf '"objects/pack/pack-%s.idx" ' $hlpacks)" \
1514 '"$cfg_reporoot/$fork.git/objects/pack/"'
1515 runupdate=1
1517 # Match upacks in repack/alt area if any
1518 if [ -n "$upacks" ]; then
1519 mkdir -p "$cfg_reporoot/$fork.git/objects/pack"
1520 eval ln -f "$(printf '"repack/alt/pack/pack-%s_u.pack" ' $upacks)" \
1521 "$(printf '"repack/alt/pack/pack-%s_u.idx" ' $upacks)" \
1522 '"$cfg_reporoot/$fork.git/objects/pack/"'
1523 runupdate=1
1525 if ! [ -e "$cfg_reporoot/$fork.git/.needsgc" ]; then
1526 # Trigger a mini gc in the fork if it now has too many packs
1527 packs="$(list_packs --quiet --count --exclude-no-idx --exclude-keep "$cfg_reporoot/$fork.git/objects/pack")" || :
1528 if [ -n "$packs" ] && [ "$packs" -ge 20 ]; then
1529 >"$cfg_reporoot/$fork.git/.needsgc"
1532 [ -z "$runupdate" ] || git --git-dir="$cfg_reporoot/$fork.git" update-server-info
1533 # Update the fork's lastparentgc date (must be more recent than $gcstart)
1534 git --git-dir="$cfg_reporoot/$fork.git" config gitweb.lastparentgc "$lastparentgc"
1535 done
1538 # Now move any primary/supplementary packs back into objects/pack
1539 # then drop any "unfreshened" redundant packs and clear repack/alt
1541 # First make sure the primary pack(s) have the most recent mod time
1542 if [ -n "$packs" ]; then
1543 [ -z "$spacks" ] || sleep 1
1544 printf 'repack/alt/pack/pack-%s.pack\n' $packs | xargs touch -c 2>/dev/null || :
1547 # Move the packs into place but with a _f suffix and a .keep file for now
1548 for pack in $packs $spacks; do
1549 rename_pack "repack/alt/pack/pack-$pack" "objects/pack/pack-${pack}_f"
1550 [ -e "objects/pack/pack-${pack}_f.keep" ] ||
1551 echo "final" >"objects/pack/pack-${pack}_f.keep"
1552 done
1554 # It's possible that one of the $oldpacks had a .bitmap, got renamed (along
1555 # with its .bitmap) and then got "freshened" causing us to not remove it
1556 # However, if $wbmopt is set we most likely now have TWO .bitmap packs!
1557 # This can produce ugly warnings we don't want and possibly get the wrong
1558 # bitmap used since only one .bitmap file can ever be used by Git.
1559 # If this has happened, the .bitmap we want to discard will always have
1560 # an _r suffix so we can just zap any such now since it will leave the pack.
1561 [ -z "$wbmopt" ] || rm -f objects/pack/pack-*_r.bitmap || :
1563 # Remove the redundant packs that have not since been "freshened"
1564 # This does not completely eliminate the race condition window (Girocco's own
1565 # activites -- gc/fetch/receive are immune to the race) but it substantially
1566 # shrinks it down to just the time after the find but before the following rm
1567 >repack/oldpacks
1568 [ -z "$oldpacks" ] ||
1569 printf 'objects/pack/%s.pack\n' $oldpacks |
1570 LC_ALL=C sort >repack/oldpacks
1571 find -L objects/pack -maxdepth 1 -type f -name "pack-$octet20*.pack" -newer .gc_in_progress -print |
1572 LC_ALL=C sort >repack/freshened
1573 deadpacks="$(LC_ALL=C join -v 1 repack/oldpacks repack/freshened | LC_ALL=C sed 's/\.pack$//')"
1574 [ -z "$deadpacks" ] ||
1575 eval echo "$(printf '"%s".* ' $deadpacks)" | xargs rm -f || :
1577 # No need for this anymore
1578 rm -rf repack/alt objects/pack/repack
1579 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
1582 ## Phase IV
1585 progress "~ [$proj] running gc prune-packed"
1587 # We do not want the redundant packs or any new "--keep-unreachable" pack(s) to be
1588 # present while running prune-packed. We try to guarantee that any loose object
1589 # (or any object present in a pack with an _l suffix which was created by mini gc)
1590 # that's unreachable persists for at least one $Girocco::Config::min_gc_interval
1591 # (not withstanding administrator interference to force earlier gc to occur).
1592 # If we were to include the redundant/keep-unreachable pack(s) when running
1593 # prune-packed and a loose unreachable object happened to be duplicated in one
1594 # of them we would end up removing it too soon and void our guarantee.
1595 git prune-packed $quiet
1597 progress "~ [$proj] running loose objects gc pack-objects ($(date))"
1599 # Although Git v2.10.0 and later support a --pack-loose-unreachable option,
1600 # we MUST NOT use it for these reasons:
1601 # 1) We're not interested in expensive "unreachable" at this point, only "loose"
1602 # 2) It produces simply horrid packs about 3.8x times larger than they should be
1603 # 3) We don't require anything more than Git v1.6.6
1604 # The only way we could see any _o pack files at this point is if one got
1605 # "freshened" while we were running gc. If that happens then it gets to live on
1606 # until the next full gc and we need to include it in the loose repack here.
1607 lpacks="$(list_packs --exclude-no-idx --exclude-no-sfx _l --exclude-no-sfx _o --quiet objects/pack |
1608 run_combine_packs --replace --names --loose --weak-naming --non-empty --honor-pack-keep \
1609 --all-progress-implied ${quiet:---progress} $packopts $newdeltas "$@")"
1611 if [ -n "$lpacks" ]; then
1612 # Make sure any primary pack(s) have a more recent mod time than "unreachable" objects packs
1613 if [ -n "$packs" ]; then
1614 sleep 1
1615 printf 'objects/pack/pack-%s_f.pack\n' $packs | xargs touch -c 2>/dev/null || :
1617 # We need to identify these packs later so we don't combine_packs them
1618 for objpack in $lpacks; do
1619 rename_pack "objects/pack/pack-$objpack" "objects/pack/pack-${objpack}_o" || :
1620 done
1623 # Polish up the final packs now
1624 rm -f objects/pack/pack-*_f.keep
1625 for pack in $packs $spacks; do
1626 rename_pack "objects/pack/pack-${pack}_f" "objects/pack/pack-$pack"
1627 done
1629 if [ -n "$lpacks" ]; then
1630 # Finally zap the corresponding loose objects
1631 progress "~ [$proj] running packed loose objects gc prune-packed"
1632 git prune-packed $quiet
1635 ! [ -e .gc_failed ] || exit 1
1636 # These, if they exist, are now meaningless and need to be removed
1637 rm -f gfi-packs .needsgc .needspack .needspackgc
1639 # Make sure this stays up to date
1640 git update-server-info
1642 # We must make loose objects group writable so that they
1643 # can be freshened by other pushers. Technically we need only do this for
1644 # push projects but to enable mirror projects to be more easily converted to
1645 # push projects, we go ahead and do it for all projects.
1646 # By the time we get here we really shouldn't have any of these, but just in case.
1647 { find -L objects/$octet -type f -name "$octet19*" -exec chmod ug+w '{}' + || :; } 2>/dev/null
1649 # darcs:// mirrors have a xxx.log file that will grow endlessly
1650 # if this is a mirror and the file exists, shorten it to 10000 lines
1651 # also take this opportunity to optimize the darcs repo
1652 if ! [ -e .nofetch ] && [ -n "$cfg_mirror" ]; then
1653 url="$(config_get baseurl)" || :
1654 case "$url" in darcs://*)
1655 if [ -n "$cfg_mirror_darcs" ]; then
1656 url="${url%/}"
1657 basedarcs="$(basename "${url#darcs:/}")"
1658 if [ -f "$basedarcs.log" ]; then
1659 tail -n 10000 "$basedarcs.log" >"$basedarcs.log.$$"
1660 mv -f "$basedarcs.log.$$" "$basedarcs.log"
1662 if [ -d "$basedarcs.darcs" ]; then
1664 cd "$basedarcs.darcs"
1665 # without show_progress suppress non-error output
1666 [ "${show_progress:-0}" != "0" ] || exec >/dev/null
1667 # Note that this does not optimize _darcs/inventories/ :(
1668 darcs optimize || :
1672 esac
1675 # Create a matching .bndl header file for the all-in-one pack we just created
1676 # but only if we're not a fork (otherwise the bundle would not be complete)
1677 # and we are running at least Git version 1.7.2 (pack_is_complete always fails otherwise)
1678 if [ -n "$makebndl" ] && [ -n "$var_have_git_172" ]; then
1679 # There should only be one pack in $packs but do some checking...
1680 # The one we just created will have a .idx and will NOT have a .keep
1681 progress "~ [$proj] creating downloadable bundle header"
1682 pkbase=
1683 pkhead=
1684 IFS= read -r curhead <repack/HEAD.orig || :
1686 [ -s "objects/pack/pack-$packs.pack" ] &&
1687 [ -s "objects/pack/pack-$packs.idx" ] &&
1688 ! [ -e "objects/pack/pack-$packs.keep" ] &&
1689 pkhead="$(pack_is_complete "$PWD/objects/pack/pack-$packs.pack" \
1690 "$PWD/repack/packed-refs.orig" "$curhead")"
1691 then
1692 pkbase="objects/pack/pack-$packs"
1694 if [ -n "$pkbase" ] && [ -n "$pkhead" ]; then
1696 symref=
1697 case "$curhead" in "ref: refs/"?*|"ref:refs/"?*|"refs/"?*)
1698 symref="${curhead#ref:}"
1699 symref="${symref# }"
1700 esac
1701 bndlurl=
1702 [ -z "$cfg_httpbundleurl" ] || bndlurl=" url=$cfg_httpbundleurl/$proj.git/clone.bundle"
1703 echo "# v2 git bundle"
1704 LC_ALL=C sed -ne "/^$octet20$hexdig* refs\/[^ $tab]*\$/ p" <repack/packed-refs.orig
1705 if [ -n "$symref" ]; then
1706 printf "$pkhead HEAD\0symref=HEAD:%s%s\n" "$symref" "$bndlurl"
1707 else
1708 if [ -n "$bndlurl" ]; then
1709 printf "$pkhead HEAD\0%s\n" "${bndlurl:# }"
1710 else
1711 echo "$pkhead HEAD"
1714 echo ""
1715 } >"$pkbase.bndl"
1716 bndletag="$("$cfg_basedir/bin/rangecgi" --etag -m 1 "$pkbase.bndl" "$pkbase.pack")" || :
1717 bndlsha="$(printf '%s' "$bndletag" | git hash-object --stdin)" || :
1718 if [ -n "$bndletag" ]; then
1719 case "$bndlsha" in $octet20*)
1720 bndlshatrailer="${bndlsha#????????}"
1721 bndlshaprefix="${bndlsha%$bndlshatrailer}"
1722 bndlname="$(TZ=UTC date +%Y%m%d_%H%M%S)-${bndlshaprefix:-0}"
1723 [ -d bundles ] || mkdir bundles
1724 echo "${pkbase#objects/pack/}.bndl" >"bundles/$bndlname"
1725 echo "${pkbase#objects/pack/}.pack" >>"bundles/$bndlname"
1726 ln -s -f -n "$bndlname" bundles/latest
1727 esac
1732 # Record the size of this repo as the sum of its clone packed-refs + *.pack sizes as 1024-byte blocks
1733 eval "reposizek=$(( $(
1734 echo 0 $(du -k repack/packed-refs.orig $(printf 'objects/pack/pack-%s.pack ' $packs) 2>/dev/null |
1735 LC_ALL=C awk '{print $1}') |
1736 LC_ALL=C sed -e 's/ / + /g') ))"
1737 config_set_raw girocco.reposizek "${reposizek:-0}"
1739 # Now we're finally done with this
1740 rm -rf repack
1742 # We didn't used to do anything about rerere or worktrees but we're
1743 # trying to make nice with linked working trees these days :)
1744 # Maybe even non-bare repositories too, but *shush* about those ;)
1745 if [ -n "$var_have_git_250" ] && [ -d worktrees ]; then
1746 # The value "3.months.ago" is hard-coded into gc.c rather than
1747 # having the default be in worktree.c so we must provide it if
1748 # we get nothing out of the gc.worktreePruneExpire config item
1749 # Prior to Git v2.6.0 the config item was gc.pruneworktreesexpire
1750 # however we just always use the newer name no matter what Git version
1751 expiry="$(git config --get gc.worktreePruneExpire 2>/dev/null)" || :
1752 eval git worktree prune --expire '"${expiry:-3.months.ago}"' "${quiet:+>/dev/null 2>&1}" || :
1754 # git rerere does it right and handles its own default/config'd expiration values
1755 ! [ -d rr-cache ] || eval git rerere gc "${quiet:+>/dev/null 2>&1}" || :
1757 # We use $gcstart here to avoid a race where a push occurs during the gc itself
1758 # and the next future gc could be incorrectly skipped if we used the current
1759 # timestamp here instead
1760 config_set lastgc "$gcstart"
1761 rm -f "$lockf"
1763 progress "- [$proj] garbage check ($(date))"